/*!
 * @file cpectator.h
 * Implements a playable for lazy people
 */

#ifndef _SPECTATOR_H
#define _SPECTATOR_H

#include "playable.h"

class Spectator : public Playable
{
  public:
    Spectator( const TiXmlElement* root = NULL );
    virtual ~Spectator();
    
    virtual void setPlayDirection(const Quaternion& rot, float speed = 0.0f);

    virtual void enter();
    virtual void leave();
    
    virtual void collidesWith(WorldEntity* entity, const Vector& location);
    virtual void tick(float time);

    virtual void process(const Event &event);
    
  private:
    bool                  bLeft;
    bool                  bRight;
    bool                  bForward;
    bool                  bBackward;
    
    float                 xMouse;             //!< mouse moved in x-Direction
    float                 yMouse;             //!< mouse moved in y-Direction
    Quaternion            mouseDir;           //!< the direction where the player wants to fly

    Quaternion            rotY;
    Quaternion            rotAxis;
};

#endif
